归并排序 求逆序数 链表的归并排序 多线程归并排序 java

import java.util.Scanner;

public class Main {
    private static int count=0;
    public static void mergesort(int a[],int low,int high)
    {
        if(low<high)
        {
            int mid=(low+high)>>1;
             mergesort(a,low,mid);
             mergesort(a,mid+1,high);
             merge(a,low,mid,high);

        }

    }

    private static void merge(int[] a, int low, int mid, int high) {

        int temp[]=new int[high-low+1]; //开辟额外空间
        int index=0;
        int beg1=low;
        int beg2=mid+1;
        while(beg1<=mid&&beg2<=high)  //如果两者都存在,选在较少的一个
        {
            if(a[beg1]<=a[beg2])
            {
                temp[index++]=a[beg1++];
            }
            else
            {
                temp[index++]=a[beg2++];
                count+=mid-beg1+1;    //   如果选中后者,对于后者会出现mid-beg1+1的逆序数
            }

        }
        while(beg1<=mid)  //剩下的元素
        {
            temp[index++]=a[beg1++];
        }
        while(beg2<=high)
        {
            temp[index++]=a[beg2++];
        }
        for(int i=0;i<index;i++)
        {
            a[low+i]=temp[i];
        }

    }

    public static void main(String[] args) {
        // TODO Auto-generated method stub
        Scanner scn=new Scanner(System.in);
        int len=scn.nextInt();
        while(len-->0)
        {
            count=0;
            int len2=scn.nextInt();
            int a[]=new int[len2];
            for(int i=0;i<len2;i++)
            {
                a[i]=scn.nextInt();
            }

            mergesort(a,0,len2-1);

            System.out.println(count);
        }

    }

}

leetcode 中的链表排序

public class Solution {
    public ListNode sortList(ListNode head) {

        if(head==null) return null;
        if(head.next==null) return head;
          ListNode list=split(head);
          return merge(sortList(head),sortList(list));

    }
  //divide into two part ,return the middle address
    private ListNode split(ListNode head) {

        ListNode qucik=head;
        ListNode slow=head;
        ListNode pre=null;

        while(qucik!=null)
        {
           pre=slow;
           slow=slow.next;
           qucik=qucik.next;
           if(qucik!=null) qucik=qucik.next;

        }

        pre.next=null;
        return slow;

    }
    public ListNode merge(ListNode head,ListNode middle)
    {
        ListNode p1=head;
        ListNode p2=middle;
        ListNode h=new ListNode(-1);
        ListNode tail=h; //insert into tail;

        while(p1!=null&&p2!=null)
        {
            if(p1.val<=p2.val)
            {
                tail.next=p1;
                tail=tail.next;
                p1=p1.next;

            }
            else
            {
                tail.next=p2;
                tail=tail.next ;
                p2=p2.next;

            }

        }
     if(p1!=null)
     {

         tail.next=p1;
         tail=tail.next ;

     }
     if(p2!=null)
     {
         tail.next=p2;
         tail=tail.next ;

     }

        return h.next;
    }

}

多线程 的归并排序

时间: 2024-10-16 14:13:26

归并排序 求逆序数 链表的归并排序 多线程归并排序 java的相关文章

poj 2299 Ultra-QuickSort 归并排序求逆序数对

题目链接: http://poj.org/problem?id=2299 题目描述: 给一个有n(n<=500000)个数的杂乱序列,问:如果用冒泡排序,把这n个数排成升序,需要交换几次? 解题思路: 根据冒泡排序的特点,我们可知,本题只需要统计每一个数的逆序数(如果有i<j,存在a[i] > a[j],则称a[i]与 a[j]为逆序数对),输出所有的数的逆序数的和用普通排序一定会超时,但是比较快的排序,像快排又无法统计 交换次数,这里就很好地体现了归并排序的优点.典型的利用归并排序求逆

poj2299解题报告(归并排序求逆序数)

POJ 2299,题目链接http://poj.org/problem?id=2299 题意: 给出长度为n的序列,每次只能交换相邻的两个元素,问至少要交换几次才使得该序列为递增序列. 思路: 其实就是求逆序数,那么直接向到的就是冒泡了,交换一次,记录一次即可.但是n的范围达到50W,冒泡O(n^2)的复杂度铁定超时. 然后...发现曾经微软有一道笔试题类似就是求逆序数的,对,没错,用归并. 例:合并两个序列(1,3,5)(2,4,6),新序列第二个元素是2,那么它和它前面的3.5形成了逆序数对

POJ 2299 Ultra-QuickSort (求逆序数:离散化+树状数组或者归并排序求逆序数)

Ultra-QuickSort Time Limit: 7000MS   Memory Limit: 65536K Total Submissions: 55048   Accepted: 20256 Description In this problem, you have to analyze a particular sorting algorithm. The algorithm processes a sequence of n distinct integers by swappin

POJ训练计划2299_Ultra-QuickSort(归并排序求逆序数)

Ultra-QuickSort Time Limit: 7000MS   Memory Limit: 65536K Total Submissions: 39279   Accepted: 14163 Description In this problem, you have to analyze a particular sorting algorithm. The algorithm processes a sequence of n distinct integers by swappin

HDU 4911 Inversion(归并排序求逆序数)

归并排序求逆序数,然后ans-k与0取一个最大值就可以了. 也可以用树状数组做,比赛的时候可能姿势不对,树状数组wa了.. Inversion Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Total Submission(s): 578    Accepted Submission(s): 249 Problem Description bobo has a seque

POJ2299 Ultra-QuickSort(归并排序求逆序数)

归并排序求逆序数 Time Limit:7000MS     Memory Limit:65536KB     64bit IO Format:%I64d & %I64u Description In this problem, you have to analyze a particular sorting algorithm. The algorithm processes a sequence of n distinct integers by swapping two adjacent

归并排序求逆序数(排序算法)

归并排序:归并排序是建立在归并操作上的一种有效的排序算法,该算法是采用分治法(Divide and Conquer)的一个非常典型的应用.将已有序的子序列合并,得到完全有序的序列:即先使每个子序列有序,再使子序列段间有序.若将两个有序表合并成一个有序表,称为二路归并.--(摘自百度百科) 具体操作: 比较a[i]和a[j]的大小,若a[i]≤a[j],则将第一个有序表中的元素a[i]复制到r[k]中,并令i和k分别加上1:否则将第二个有序表中的元素a[j]复制到r[k]中,并令j和k分别加上1,

hiho一下 第三十九周 归并排序求逆序数

题目链接:http://hihocoder.com/contest/hiho39/problem/1 ,归并排序求逆序数. 其实这道题也是可以用树状数组来做的,不过数据都比较大,所以要离散化预处理一下,文中也会给出离散化+树状数组的解法,不过要比归并排序慢一点. 算法: 还是按照题中给的解法. 我们来看一个归并排序的过程: 给定的数组为[2, 4, 5, 3, 1],二分后的数组分别为[2, 4, 5], [1, 3],假设我们已经完成了子过程,现在进行到该数组的“并”操作: a: [2, 4,

poj-2299 Ultra—QuickSort(归并排序求逆序数)

Ultra-QuickSort Time Limit: 7000MS   Memory Limit: 65536K Total Submissions: 38688   Accepted: 13950 Description In this problem, you have to analyze a particular sorting algorithm. The algorithm processes a sequence of n distinct integers by swappin